﻿Function Remove-Driver {   
	Process {
		$retCode = 0
		$extensionInfs = @{}
		$extensionInfs3 = @{}
		
		#Get driver list; 
		$drv = PnpUtil.exe /enum-drivers
                   
		$inf = "dax3_ext_cmedia.inf"
		$ver1 = "6.1222.647.6"
		$ver2 = "7.105.819.38"
		$ver3 = "7.117.349.26"

		#Get Published Name (Ex. oem1.inf) and Class Name (ex. Extension)
		$publishedName3 = $drv | Select-String -Pattern $inf -Context 2, 5 | ForEach-Object { 
			@{ 
				"Inf"       = ($_.Context.PreContext[1] -split ':')[1].trim() ; 
				"ClassName" = ($_.Context.PostContext[1] -split ':')[1].trim() ;
				"Version"   = ($_.Context.PostContext | Select-String -Pattern $ver3) ; 
			} 
		}

		if ($publishedName3.Count -eq 0) {
			$retCode = -1
			return $retCode
		}

		foreach ($p in $publishedName3) {
			if ($p["Version"]) {
				if ($p["ClassName"] -contains "Extensions") {
					#Add into Extension Inf List
					$extensionInfs3.Add($p["Inf"], $i.Value)
				}
				else {
					#Uninstall driver
					PnpUtil.exe /delete-driver $p["Inf"] /uninstall /force

					switch ($LASTEXITCODE) {
						0: {} #success
						259: {} #reboot
						default: { $retCode = $LASTEXITCODE }
					}

				}
			}
		}    

		if ($extensionInfs3.Count -eq 0) {
			$retCode = -1
			return $retCode
		}

		#Get Published Name (Ex. oem1.inf) and Class Name (ex. Extension)
		$publishedName2 = $drv | Select-String -Pattern $inf -Context 2, 5 | ForEach-Object { 
			@{ 
				"Inf"       = ($_.Context.PreContext[1] -split ':')[1].trim() ; 
				"ClassName" = ($_.Context.PostContext[1] -split ':')[1].trim() ;
				"Version"   = ($_.Context.PostContext | Select-String -Pattern $ver2) ; 
			} 
		}

		foreach ($p in $publishedName2) {
			if ($p["Version"]) {
				if ($p["ClassName"] -contains "Extensions") {
					#Add into Extension Inf List
					$extensionInfs.Add($p["Inf"], $i.Value)
				}
			}
		}    

		#Get Published Name (Ex. oem1.inf) and Class Name (ex. Extension)
		$publishedName1 = $drv | Select-String -Pattern $inf -Context 2, 5 | ForEach-Object { 
			@{ 
				"Inf"       = ($_.Context.PreContext[1] -split ':')[1].trim() ; 
				"ClassName" = ($_.Context.PostContext[1] -split ':')[1].trim() ;
				"Version"   = ($_.Context.PostContext | Select-String -Pattern $ver1) ; 
			} 
		}

		foreach ($p in $publishedName1) {
			if ($p["Version"]) {
				if ($p["ClassName"] -contains "Extensions") {
					#Add into Extension Inf List
					$extensionInfs.Add($p["Inf"], $i.Value)
				}
			}
		}    

		foreach ($e in $extensionInfs.Keys) {
			#Uninstall Extension Inf
			PnpUtil.exe /delete-driver $e /uninstall /force

			switch ($LASTEXITCODE) {
				0: {} #success
				259: {} #reboot
				default: { $retCode = $LASTEXITCODE }
			}

		}

		return $retCode
	}
}

Remove-Driver
